package com.gxzc.zen.api.sys.service

import com.gxzc.zen.api.sys.model.SysDic
import com.gxzc.zen.common.base.BaseService

/**
 * <p>
 * 字典表 服务类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
interface ISysDicService : BaseService<SysDic> {
    /**
     * 查询所有列表(where enable=1)
     */
    fun selectList(): MutableList<SysDic>

    /**
     * 根据key获取对应的SysDic列表
     */
    fun getListByKey(key: String): MutableList<SysDic>

    /**
     * 获取一个SysDic,若查询结果大于1个则取sort所指代的
     */
    fun getOneByKey(key: String, sort: Int): SysDic?

    /**
     * 修改SysDic项
     * 更新缓存项
     * TODO 同时通知其他系统
     */
    fun modifySysDic(sysDic: SysDic): SysDic
}
