package com.gxzc.zen.api.sys.service.impl

import com.gxzc.zen.api.sys.model.SysUser
import com.gxzc.zen.api.sys.mapper.SysUserMapper
import com.gxzc.zen.api.sys.service.ISysUserService
import com.baomidou.mybatisplus.service.impl.ServiceImpl
import com.gxzc.zen.common.contants.CACHEKEYS
import org.springframework.cache.annotation.Cacheable
import org.springframework.stereotype.Service

/**
 * <p>
 * 用户管理 服务实现类
 * </p>
 *
 * @author NorthLan123
 * @since 2018-02-06
 */
@Service
class SysUserServiceImpl : ServiceImpl<SysUserMapper, SysUser>(), ISysUserService {

    @Cacheable(CACHEKEYS.USER, key = "'account_' + #account")
    override fun getUserByAccountCacheable(account: String): SysUser? {
        return baseMapper.selectByAccount(account)
    }

    @Cacheable(CACHEKEYS.USER)
    override fun getUserByIdCacheable(id: Long): SysUser {
        return baseMapper.selectById(id)
    }

}
