package com.gxzc.zen.common.config.json

import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.http.converter.HttpMessageConverter
import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter

/**
 * 使Spring boot处理自定义jsonhandler
 * @author NorthLan
 * @date 2018/3/12
 * @url https://noahlan.com
 */
@Configuration
class ZenJsonConfigurer : WebMvcConfigurerAdapter() {
    companion object {
        const val CONVERTER_NAME = "hookMappingJackson2HttpMessageConverter"
    }

    override fun configureMessageConverters(converters: MutableList<HttpMessageConverter<*>>) {
        super.configureMessageConverters(converters)
        converters.add(getConverter())
    }

    @Bean(CONVERTER_NAME)
    fun getConverter(): MappingJackson2HttpMessageConverter {
        return MappingJackson2HttpMessageConverter()
    }
}