package com.gxzc.zen.common.config.request

import com.fasterxml.jackson.databind.ObjectMapper
import com.gxzc.zen.common.config.request.annotation.ZenRequestBody
import com.gxzc.zen.common.dto.RequestDto
import org.springframework.beans.BeanUtils
import org.springframework.core.MethodParameter
import org.springframework.http.HttpInputMessage
import org.springframework.http.converter.HttpMessageConverter
import org.springframework.web.bind.annotation.ControllerAdvice
import org.springframework.web.servlet.mvc.method.annotation.RequestBodyAdviceAdapter
import java.lang.reflect.Type
import kotlin.reflect.full.createInstance

/**
 *
 * @author NorthLan
 * @date 2018/3/16
 * @url https://noahlan.com
 */
@ControllerAdvice
class ZenRequestBodyAdvice : RequestBodyAdviceAdapter() {
    override fun supports(methodParameter: MethodParameter, targetType: Type, converterType: Class<out HttpMessageConverter<*>>): Boolean {
        return methodParameter.hasParameterAnnotation(ZenRequestBody::class.java)
    }

    override fun beforeBodyRead(inputMessage: HttpInputMessage, parameter: MethodParameter, targetType: Type, converterType: Class<out HttpMessageConverter<*>>): HttpInputMessage {
        return super.beforeBodyRead(inputMessage, parameter, targetType, converterType)
    }

    override fun afterBodyRead(body: Any, inputMessage: HttpInputMessage, parameter: MethodParameter, targetType: Type, converterType: Class<out HttpMessageConverter<*>>): Any {
        val b = body as RequestDto
        val d = b["data"]

        val typ = parameter.getParameterAnnotation(ZenRequestBody::class.java).value[0].value
//        val c = typ.createInstance()

        val a = ObjectMapper().readValue(ObjectMapper().writeValueAsString(d), typ::class.java)


        return super.afterBodyRead(body, inputMessage, parameter, targetType, converterType)
    }

}