package com.gxzc.zen.common.exception

/**
 * 基本业务异常的枚举
 * @author NorthLan
 * @date 2018/2/28
 * @url https://noahlan.com
 */
enum class ZenExceptionEnum(val code: Int, val msg: String) {
    /**
     * Auth
     */
    AUTH_ACCOUNT_NOT_EXISTS(100, "账号不存在"),
    AUTH_PASSWORD_ERROR(101, "密码错误"),
    AUTH_NO_LOGIN(102, "未登录"),

    /**
     * 文件上传
     */
    FILE_READING_ERROR(400, "FILE_READING_ERROR!"),
    FILE_NOT_FOUND(400, "FILE_NOT_FOUND!"),

    /**
     * 错误的请求
     */
    REQUEST_NULL(400, "请求有错误"),
    SERVER_ERROR(500, "服务器异常");
}