package com.gxzc.zen.orm.config

import com.baomidou.mybatisplus.mapper.LogicSqlInjector
import com.baomidou.mybatisplus.plugins.PaginationInterceptor
import com.baomidou.mybatisplus.plugins.PerformanceInterceptor
import org.mybatis.spring.annotation.MapperScan
import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.context.annotation.Profile
import org.springframework.transaction.annotation.EnableTransactionManagement

/**
 *
 * @author NorthLan at 2018/1/30
 */
@Configuration
@MapperScan("com.gxzc.zen.api.*.mapper")
@EnableTransactionManagement(order = 2)
class MybatisPlusConfig {

    /**
     * 性能分析插件
     */
    @Bean
    @Profile("dev") // 开发环境开启
    fun performanceInterceptor(): PerformanceInterceptor {
        return PerformanceInterceptor().also { it.isFormat = true }
    }

    /**
     * 分页插件
     */
    @Bean
    fun paginationInterceptor(): PaginationInterceptor {
        return PaginationInterceptor()
    }
//
//    /**
//     * 逻辑删插件
//     */
//    @Bean
//    fun logicSqlInjector(): LogicSqlInjector {
//        return LogicSqlInjector()
//    }
}