package com.gxzc.zen.web.sys.controller

import com.baomidou.kisso.annotation.Action
import com.baomidou.kisso.annotation.Login
import com.gxzc.zen.api.sys.model.SysDic
import com.gxzc.zen.api.sys.service.ISysDicService
import com.gxzc.zen.api.sys.service.ISysParamService
import com.gxzc.zen.common.base.BaseController
import com.gxzc.zen.common.config.request.annotation.KVType
import com.gxzc.zen.common.config.request.annotation.ZenRequestBody
import com.gxzc.zen.common.dto.RequestDto
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

/**
 *
 * @author NorthLan
 * @date 2018/3/15
 * @url https://noahlan.com
 */
@RestController
@RequestMapping("test")
class TestController : BaseController() {

    @Autowired
    private lateinit var sysDicService: ISysDicService

    @Autowired
    private lateinit var sysParamService: ISysParamService

    @GetMapping("logicDel")
    @Login(action = Action.Skip)
    fun testLogicDelete() {
        sysDicService.deleteById(4L)
    }

    @PutMapping("metaObject")
    @Login(action = Action.Skip)
    fun testCustomMetaObjectHandler() {
        sysDicService.updateById(SysDic().apply {
            id = 4
            key = "2333"
        })
    }

    @GetMapping("logicSelect")
    @Login(action = Action.Skip)
    fun testLogicSelect() {
        sysDicService.selectList(null)
    }

    @PostMapping("testInput")
    @Login(action = Action.Skip)
    fun testInput(@RequestBody
                  data: SysDic) {
        var a = 2
        a = 3
    }
}